<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>OpenThread: src/core/crypto/aes_ccm.hpp Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="../../Open-Thread-Logo-200x42.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">
   &#160;<span id="projectnumber">gddd0704</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="../../annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="../../files.html"><span>File&#160;List</span></a></li>
      <li><a href="../../globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('d0/da7/aes__ccm_8hpp_source.html','../../');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">aes_ccm.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="../../d0/da7/aes__ccm_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> *  Copyright (c) 2016, The OpenThread Authors.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *  All rights reserved.</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *  Redistribution and use in source and binary forms, with or without</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> *  modification, are permitted provided that the following conditions are met:</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *  1. Redistributions of source code must retain the above copyright</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     notice, this list of conditions and the following disclaimer.</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *  2. Redistributions in binary form must reproduce the above copyright</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> *     notice, this list of conditions and the following disclaimer in the</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> *     documentation and/or other materials provided with the distribution.</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> *  3. Neither the name of the copyright holder nor the</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *     names of its contributors may be used to endorse or promote products</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *     derived from this software without specific prior written permission.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS &quot;AS IS&quot;</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> *  POSSIBILITY OF SUCH DAMAGE.</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#ifndef AES_CCM_HPP_</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#define AES_CCM_HPP_</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#include &lt;stdint.h&gt;</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../dc/dbf/openthread-types_8h.html">openthread-types.h</a>&gt;</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../d3/d71/aes__ecb_8hpp.html">crypto/aes_ecb.hpp</a>&gt;</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="keyword">namespace </span><a class="code" href="../../d9/d00/namespaceThread.html">Thread</a> {</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="keyword">namespace </span>Crypto {</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno"><a class="line" href="../../d2/dde/classThread_1_1Crypto_1_1AesCcm.html">   56</a></span>&#160;<span class="keyword">class </span><a class="code" href="../../d2/dde/classThread_1_1Crypto_1_1AesCcm.html">AesCcm</a></div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;{</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <a class="code" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> <a class="code" href="../../d2/dde/classThread_1_1Crypto_1_1AesCcm.html#afa12aabd74472bb1c8bf6e8bb73430d4">SetKey</a>(<span class="keyword">const</span> uint8_t *aKey, uint16_t aKeyLength);</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d2/dde/classThread_1_1Crypto_1_1AesCcm.html#aa7dabbd99f28efd22176e6fed8ce2eb3">Init</a>(uint32_t aHeaderLength, uint32_t aPlainTextLength, uint8_t aTagLength,</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;              <span class="keyword">const</span> <span class="keywordtype">void</span> *aNonce, uint8_t aNonceLength);</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d2/dde/classThread_1_1Crypto_1_1AesCcm.html#a2c363bc7a25302a14931bb33d41ee15a">Header</a>(<span class="keyword">const</span> <span class="keywordtype">void</span> *aHeader, uint32_t aHeaderLength);</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d2/dde/classThread_1_1Crypto_1_1AesCcm.html#a5d36c3f13b85f66ea1e51627ec7d4297">Payload</a>(<span class="keywordtype">void</span> *aPlainText, <span class="keywordtype">void</span> *aCipherText, uint32_t aLength, <span class="keywordtype">bool</span> aEncrypt);</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="../../d2/dde/classThread_1_1Crypto_1_1AesCcm.html#a666e2ddbf5e0cf91abc191221254fcb8">Finalize</a>(<span class="keywordtype">void</span> *aTag, uint8_t *aTagLength);</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    <a class="code" href="../../d4/db8/classThread_1_1Crypto_1_1AesEcb.html">AesEcb</a> mEcb;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    uint8_t mBlock[<a class="code" href="../../d4/db8/classThread_1_1Crypto_1_1AesEcb.html#a583faab8e0af9c0988bd15f830f5bce9a04d8c6ac721519580cc405500e252aba">AesEcb::kBlockSize</a>];</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    uint8_t mCtr[<a class="code" href="../../d4/db8/classThread_1_1Crypto_1_1AesEcb.html#a583faab8e0af9c0988bd15f830f5bce9a04d8c6ac721519580cc405500e252aba">AesEcb::kBlockSize</a>];</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    uint8_t mCtrPad[<a class="code" href="../../d4/db8/classThread_1_1Crypto_1_1AesEcb.html#a583faab8e0af9c0988bd15f830f5bce9a04d8c6ac721519580cc405500e252aba">AesEcb::kBlockSize</a>];</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    uint8_t mNonceLength;</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    uint32_t mHeaderLength;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    uint32_t mHeaderCur;</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    uint32_t mPlainTextLength;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    uint32_t mPlainTextCur;</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    uint16_t mBlockLength;</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    uint16_t mCtrLength;</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    uint8_t mTagLength;</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;};</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;}  <span class="comment">// namespace Crypto</span></div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;}  <span class="comment">// namespace Thread</span></div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;<span class="preprocessor">#endif  // AES_CCM_HPP_</span></div><div class="ttc" id="classThread_1_1Crypto_1_1AesEcb_html"><div class="ttname"><a href="../../d4/db8/classThread_1_1Crypto_1_1AesEcb.html">Thread::Crypto::AesEcb</a></div><div class="ttdoc">This class implements AES ECB computation. </div><div class="ttdef"><b>Definition:</b> aes_ecb.hpp:53</div></div>
<div class="ttc" id="classThread_1_1Crypto_1_1AesCcm_html_afa12aabd74472bb1c8bf6e8bb73430d4"><div class="ttname"><a href="../../d2/dde/classThread_1_1Crypto_1_1AesCcm.html#afa12aabd74472bb1c8bf6e8bb73430d4">Thread::Crypto::AesCcm::SetKey</a></div><div class="ttdeci">ThreadError SetKey(const uint8_t *aKey, uint16_t aKeyLength)</div><div class="ttdoc">This method sets the key. </div><div class="ttdef"><b>Definition:</b> aes_ccm.cpp:41</div></div>
<div class="ttc" id="openthread-types_8h_html_ab701d053a9c34ab7f11e43e0dc09ac9f"><div class="ttname"><a href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a></div><div class="ttdeci">ThreadError</div><div class="ttdoc">This enumeration represents error codes used throughout OpenThread. </div><div class="ttdef"><b>Definition:</b> openthread-types.h:75</div></div>
<div class="ttc" id="classThread_1_1Crypto_1_1AesCcm_html_a5d36c3f13b85f66ea1e51627ec7d4297"><div class="ttname"><a href="../../d2/dde/classThread_1_1Crypto_1_1AesCcm.html#a5d36c3f13b85f66ea1e51627ec7d4297">Thread::Crypto::AesCcm::Payload</a></div><div class="ttdeci">void Payload(void *aPlainText, void *aCipherText, uint32_t aLength, bool aEncrypt)</div><div class="ttdoc">This method processes the payload. </div><div class="ttdef"><b>Definition:</b> aes_ccm.cpp:193</div></div>
<div class="ttc" id="classThread_1_1Crypto_1_1AesCcm_html_a2c363bc7a25302a14931bb33d41ee15a"><div class="ttname"><a href="../../d2/dde/classThread_1_1Crypto_1_1AesCcm.html#a2c363bc7a25302a14931bb33d41ee15a">Thread::Crypto::AesCcm::Header</a></div><div class="ttdeci">void Header(const void *aHeader, uint32_t aHeaderLength)</div><div class="ttdoc">This method processes the header. </div><div class="ttdef"><b>Definition:</b> aes_ccm.cpp:161</div></div>
<div class="ttc" id="aes__ecb_8hpp_html"><div class="ttname"><a href="../../d3/d71/aes__ecb_8hpp.html">aes_ecb.hpp</a></div><div class="ttdoc">This file includes definitions for performing AES-ECB computations. </div></div>
<div class="ttc" id="classThread_1_1Crypto_1_1AesEcb_html_a583faab8e0af9c0988bd15f830f5bce9a04d8c6ac721519580cc405500e252aba"><div class="ttname"><a href="../../d4/db8/classThread_1_1Crypto_1_1AesEcb.html#a583faab8e0af9c0988bd15f830f5bce9a04d8c6ac721519580cc405500e252aba">Thread::Crypto::AesEcb::kBlockSize</a></div><div class="ttdoc">AES-128 block size (bytes). </div><div class="ttdef"><b>Definition:</b> aes_ecb.hpp:58</div></div>
<div class="ttc" id="openthread-types_8h_html"><div class="ttname"><a href="../../dc/dbf/openthread-types_8h.html">openthread-types.h</a></div><div class="ttdoc">This file defines the types and structures used in the OpenThread library API. </div></div>
<div class="ttc" id="classThread_1_1Crypto_1_1AesCcm_html_aa7dabbd99f28efd22176e6fed8ce2eb3"><div class="ttname"><a href="../../d2/dde/classThread_1_1Crypto_1_1AesCcm.html#aa7dabbd99f28efd22176e6fed8ce2eb3">Thread::Crypto::AesCcm::Init</a></div><div class="ttdeci">void Init(uint32_t aHeaderLength, uint32_t aPlainTextLength, uint8_t aTagLength, const void *aNonce, uint8_t aNonceLength)</div><div class="ttdoc">This method initializes the AES CCM computation. </div><div class="ttdef"><b>Definition:</b> aes_ccm.cpp:47</div></div>
<div class="ttc" id="namespaceThread_html"><div class="ttname"><a href="../../d9/d00/namespaceThread.html">Thread</a></div><div class="ttdef"><b>Definition:</b> cli.cpp:61</div></div>
<div class="ttc" id="classThread_1_1Crypto_1_1AesCcm_html_a666e2ddbf5e0cf91abc191221254fcb8"><div class="ttname"><a href="../../d2/dde/classThread_1_1Crypto_1_1AesCcm.html#a666e2ddbf5e0cf91abc191221254fcb8">Thread::Crypto::AesCcm::Finalize</a></div><div class="ttdeci">void Finalize(void *aTag, uint8_t *aTagLength)</div><div class="ttdoc">This method generates the tag. </div><div class="ttdef"><b>Definition:</b> aes_ccm.cpp:254</div></div>
<div class="ttc" id="classThread_1_1Crypto_1_1AesCcm_html"><div class="ttname"><a href="../../d2/dde/classThread_1_1Crypto_1_1AesCcm.html">Thread::Crypto::AesCcm</a></div><div class="ttdoc">This class implements AES CCM computation. </div><div class="ttdef"><b>Definition:</b> aes_ccm.hpp:56</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="../../dir_aebb8dcc11953d78e620bbef0b9e2183.html">core</a></li><li class="navelem"><a class="el" href="../../dir_a9760aab0a13ba3266f05debb79c7f5d.html">crypto</a></li><li class="navelem"><a class="el" href="../../d0/da7/aes__ccm_8hpp.html">aes_ccm.hpp</a></li>
    <li class="footer">Generated on Fri Oct 14 2016 08:44:33 for OpenThread by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="../../doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
